 uses Crt;

 label BeginProg,QuitProg,SaveConfig,MainProg;

 var a: Byte;
     var sl:string;
     Base_Port,Sample: Word;
     S_Card,IRQ,DMA_Num,IRQ_Num: Word;
     F: File;
     CardInfo: array [0..13] of Byte;

 function ByteToHex(B: Byte): String;
 const HexTable: array [0..15] of Char=('0','1','2','3','4','5','6','7',
                                        '8','9','A','B','C','D','E','F');
 var HexStr: String;
 begin
  HexStr[2]:=HexTable[B and $0F];
  HexStr[1]:=HexTable[B and $F0 div 16];
  HexStr[0]:=#2;
  ByteToHex:=HexStr;
 end;

 function WordToHEX(W: Word): String;
 begin
  WordToHEX:=ByteToHEX(Hi(W))+ByteToHEX(Lo(W));
 end;

 procedure Border1(x,y,x1,y1:byte);
 var i:byte;
 begin
  for i:=x+1 to x1-1 do begin
   gotoxy(i,y);  write('');
   gotoxy(i,y1); write('');
  end;
  for i:=y+1 to y1-1 do begin
   gotoxy(x,i);  write('');
   gotoxy(x1,i); write('');
  end;
  gotoxy(x,y);   write('');
  gotoxy(x1,y);  write('');
  gotoxy(x,y1);  write('');
  gotoxy(x1,y1); write('');
 end;

 procedure Area1(x,y,x1,y1:byte);
 var i,j:byte;
 begin
  for i:=y to y1 do begin
   gotoxy(x,i);
   for j:=x to x1 do write('');
  end;
 end;

 procedure CursorOn; assembler;
      asm
        mov ah,1
        mov ch,6
        mov cl,7
        int 10h
 end;

 procedure CursorOff; assembler;
      asm
        mov ah,1
        mov ch,26h
        mov cl,7
        int 10h
 end;

 procedure NormalWindow;
 begin
  Window(1,1,80,25);
 end;

 function XReadKey: Char; assembler;
      asm
        xor     ax,ax
        int     $16
 end;

 function ReadNum(LRange,HRange: Byte): Byte;
 var Ch: Char;
 begin
  repeat
   Ch:=xReadKey;
   if Byte(Ch)=27 then begin ReadNum:=10; Exit; end;
  until (Byte(Ch)-48>=LRange) and (Byte(Ch)-48<=HRange);
  ReadNum:=Byte(Ch)-48;
 end;

 begin
  Base_Port:=$220;
  S_Card:=$01;
  IRQ_Num:=$05;
  DMA_Num:=$01;
  Sample:=22222;

  sl:='          ';
  sl:=sl+sl+sl+sl+sl;
  sl:=sl+sl+sl+sl+sl+'    Sound Card Setup by Vadim Bodrov';

BeginProg:
  NormalWindow;
  CheckBreak:=false;
  CursorOff;
  TextBackGround(Black);
  TextColor(White);
  Area1(1,1,80,25);
  TextColor(DarkGray);
  Area1(30,8,53,23);
  Area1(22,3,61,5);
  TextColor(White);
  TextBackGround(Red);
  Border1(20,2,59,4);
  GotoXY(21,3);
  Write('           SET SOUND UTILITY          ');
  TextBackGround(Black);
  TextColor(Yellow);
  TextBackGround(Blue);
  Border1(28,7,51,22);
  Window(29,8,50,21);

MainProg:
  ClrScr;
  TextColor(LightCyan);
  Writeln;
  Writeln('   Coose Sound Card');
  TextColor(White);
  Writeln;
  Writeln;
  Writeln('     1. SB (mono)');
  Writeln;
  Writeln('     2. SBPro');
  Writeln;
  Writeln('     3. SB16');
  Writeln;
  Writeln('     4. PAS+/16');
  Writeln;
  Writeln('     5. GUS');
  Writeln;
  Writeln('     0. NoSound');
  a:=ReadNum(0,5);
  if a=10 then begin
   NormalWindow;
   TextColor(White);
   TextBackGround(Black);
   ClrScr;
   Writeln;
   Writeln('Configuration file not saved!');
   Goto QuitProg;
  end;
  S_Card:=a;
  case a Of
  0: Goto SaveConfig;
  1,2,3,5: begin
      ClrScr;
      TextColor(LightCyan);
      Writeln;
      Writeln('   Coose  Base Port');
      TextColor(White);
      Writeln;
      Writeln;
      Writeln('        1. 210h');
      Writeln('        2. 220h');
      Writeln('        3. 230h');
      Writeln('        4. 240h');
      Writeln('        5. 250h');
      Writeln('        6. 260h');
      Writeln('        7. 270h');
      Writeln('        8. 280h');
      a:=ReadNum(1,8);
      if a=10 then Goto MainProg;
      Base_Port:=$200+$10*a;
     end;
   4: begin
      ClrScr;
      TextColor(LightCyan);
      Writeln;
      Writeln('   Coose  Base Port');
      TextColor(White);
      Writeln;
      Writeln;
      Writeln;
      Writeln('        1. 338h');
      Writeln('        2. 384h');
      Writeln('        3. 38Ch');
      Writeln('        4. 288h');
      Writeln('        5. 280h');
      Writeln('        6. 284h');
      Writeln('        7. 28Ch');
      a:=ReadNum(1,7);
      if a=10 then Goto MainProg;
       case a of
        1: Base_Port:=$338;
        2: Base_Port:=$384;
        3: Base_Port:=$38C;
        4: Base_Port:=$288;
        5: Base_Port:=$280;
        6: Base_Port:=$284;
        7: Base_Port:=$28C;
        10: Goto MainProg;
       end;
      end;
  end;
  if S_Card=5 then begin IRQ:=11; Sample:=44100; goto SaveConfig; end;
  ClrScr;
  TextColor(LightCyan);
  Writeln;
  Writeln('   Coose  DMA NUMBER');
  TextColor(White);
  Writeln;
  Writeln;
  Writeln('         0. 00');
  Writeln('         1. 01');
  Writeln('         2. 02');
  Writeln('         3. 03');
  Writeln('         4. 04');
  Writeln('         5. 05');
  Writeln('         6. 06');
  Writeln('         7. 07');
  a:=ReadNum(0,7);
  if a=10 then Goto MainProg;
  DMA_Num:=a;
  ClrScr;
  TextColor(LightCyan);
  Writeln;
  Writeln('   Coose  IRQ NUMBER');
  TextColor(White);
  Writeln;
  Writeln;
  Writeln('         1. 02');
  Writeln('         2. 03');
  Writeln('         3. 05');
  Writeln('         4. 07');
  Writeln('         5. 0A');
  a:=ReadNum(1,5);
  if a=10 then Goto MainProg;
  case a of
   1: IRQ_Num:=02;
   2: IRQ_Num:=03;
   3: IRQ_Num:=05;
   4: IRQ_Num:=07;
   5: IRQ_Num:=10;
  end;
  ClrScr;
  Writeln;
  Writeln('   Coose Sample Rate');
  TextColor(White);
  Writeln;
  Writeln;
  Writeln('        1. 10000');
  Writeln('        2. 13000');
  Writeln('        3. 18000');
  Writeln('        4. 20000');
  Writeln('        5. 22000');
  if (S_Card<>1) and (S_Card<>2) then begin
   Writeln('        6. 34000');
   Writeln('        7. 44100');
  end;
  if (S_Card<>1) and (S_Card<>2) then a:=ReadNum(1,7) else a:=ReadNum(1,5);
  if a=10 then Goto MainProg;
  case a Of
   1: Sample:=10000;
   2: Sample:=13000;
   3: Sample:=18000;
   4: Sample:=20000;
   5: Sample:=22000;
   6: Sample:=34000;
   7: Sample:=44100;
  end;
SaveConfig:
   NormalWindow;
   TextColor(DarkGray);
   TextBackGround(Black);
   Area1(22,11,62,24);
   TextBackGround(Green);
   TextColor(White);
   Border1(20,9,60,23);
   Window(21,10,59,22);
   ClrScr;
   TextColor(White);
   Writeln;
   if S_Card=1 then Writeln('             Sound Blaster');
   if S_Card=2 then Writeln('           Sound Blaster Pro');
   if S_Card=3 then Writeln('           Sound Blaster 16');
   if S_Card=4 then Writeln('        Pro Audio Spectrum+/16');
   if S_Card=5 then GotoXY(1,6);
   if S_Card=5 then Writeln('          Gravis Ultra Sound');
   if S_Card=0 then Writeln('                No Sound');
   if (S_Card<>5) and (S_Card<>0) then begin
    Writeln;
    Writeln('            Base Port: ',WordToHex(Base_Port),'h');
    Writeln;
    Writeln('                IRQ: ',IRQ_Num);
    Writeln;
    Writeln('                DMA: ',DMA_Num);
   end;
   GotoXY(1,10);
   if S_Card<>0 then Writeln('           Sample Rate: ',Sample);
   Writeln;
   TextColor(Yellow);
   Writeln('   Press any key to save config file');
   Writeln('   or press "ESC" key to start again');
   a:=Byte(xReadKey);
   if a=27 then Goto BeginProg;
{$I-}
   Assign(f,'mmdrv.cfg');
   Rewrite(f);
{$I+}
   if IOResult<>0 then begin
    NormalWindow;
    TextColor(White);
    TextBackGround(Black);
    ClrScr;
    Writeln;
    Writeln('Can`t write to file!');
    goto QuitProg;
   end;
{$I-}
   asm sub [S_Card],1 end;
   CardInfo[00]:=Lo(Base_Port);
   CardInfo[01]:=Hi(Base_Port);
   CardInfo[02]:=DMA_Num;
   CardInfo[03]:=IRQ_Num;
   CardInfo[04]:=Lo(Sample);
   CardInfo[05]:=Hi(Sample);
   CardInfo[06]:=S_Card;
   CardInfo[07]:=$00;
   CardInfo[08]:=$00;
   CardInfo[09]:=$00;
   CardInfo[10]:=$00;
   CardInfo[11]:=$FF;
   CardInfo[12]:=$FF;
   CardInfo[13]:=$FF;
   BlockWrite(f,CardInfo,SizeOf(CardInfo));
   Close(f);
{$I+}
   if IOResult<>0 then begin
    NormalWindow;
    TextColor(White);
    TextBackGround(Black);
    ClrScr;
    Writeln;
    Writeln('Disk I/O Error!');
    Goto QuitProg;
   end;
   NormalWindow;
   TextColor(White);
   TextBackGround(Black);
   ClrScr;
   Writeln;
   Writeln('Configuration file saved to "mmdrv.cfg".');
QuitProg:
  CursorOn;
 end.